// Support.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <string>
#include "VirtualBox.h"

using namespace std;

BOOL createVM(IVirtualBox *virtualBox)
{
	IMachine *iMachine = NULL;		// GuestMachine Object
	HRESULT rc;						//result

	/* Initialize the COM subsystem. */
	CoInitialize(NULL);

	/* Instantiate the VirtualBox root object.   */
	rc = CoCreateInstance(CLSID_VirtualBox,       /* the VirtualBox base object */
		NULL,                   /* no aggregation */
		CLSCTX_LOCAL_SERVER,    /* the object lives in a server process on this machine */
		IID_IVirtualBox,        /* IID of the interface */
		(void**)&virtualBox);

	if (!SUCCEEDED(rc))
	{
		printf("Error creating VirtualBox instance! rc = 0x%x\n", rc);
	}

	//BSTR settingsFileName	= SysAllocString(L"H:\\VitualVHD's\\Xp32\\xp32.vhd");
	BSTR m_MachineName		= SysAllocString(L"Sample");
	BSTR machineName		= ::SysAllocString(m_MachineName);
	BSTR m_OSName			= SysAllocString(L"Windows7");
	BSTR type				= ::SysAllocString(m_OSName);

	IGuestOSType* os = NULL;
	rc = virtualBox->GetGuestOSType(type, &os);
	BSTR guid = NULL;
	int abc = os->get_Id(&guid);
	rc = S_FALSE;
	rc = virtualBox->CreateMachine(NULL,machineName,NULL,guid,NULL,&iMachine);
	return TRUE;
}

int main(int argc, char *argv[])
{
	HRESULT rc;
	IVirtualBox *virtualBox;

	wstring machineName		= L"Mohan_XP";	
	wstring machineOS		= L"XP";	
	ULONG machineRAM		= 512;
	wstring MachineVhdToUse	= L"H:\\Disk2_full.vmdk";
	wstring MachineChipSet	= L"PIIX3";
	BOOL MachineIOapic		= TRUE;

	do
	{
		/* Initialize the COM subsystem. */
		CoInitialize(NULL);

		/* Instantiate the VirtualBox root object. */
		rc = CoCreateInstance(CLSID_VirtualBox,       /* the VirtualBox base object */
			NULL,                   /* no aggregation */
			CLSCTX_LOCAL_SERVER,    /* the object lives in a server process on this machine */
			IID_IVirtualBox,        /* IID of the interface */
			(void**)&virtualBox);

		if (!SUCCEEDED(rc))
		{
			printf("Error creating VirtualBox instance! rc = 0x%x\n", rc);
			break;
		}

		createVM(virtualBox);

		/* Release the VirtualBox object. */
		virtualBox->Release();

	} while (0);

	CoUninitialize();
	return 0;
}